import * as Oni from "oni-api";
import { IEvent } from "oni-types";
import { QuickOpenItem } from "./QuickOpenItem";
export interface QuickOpenResult {
    items: QuickOpenItem[];
    isComplete: boolean;
}
export interface IAsyncSearch {
    cancel(): void;
    changeQueryText(newText: any): void;
    onSearchResults: IEvent<QuickOpenResult>;
}
export declare class QuickOpen {
    private _oni;
    private _menu;
    private _searcher;
    private _seenItems;
    private _itemsFound;
    private _bookmarksSearch;
    constructor(_oni: Oni.Plugin.Api);
    isOpen(): boolean;
    open(mode: Oni.FileOpenMode): Promise<void>;
    setToQuickFix: () => Promise<void>;
    openFileWithAltAction: () => void;
    searchFileByContent: () => Promise<void>;
    searchFileByPath: () => Promise<void>;
    showBufferLines: () => Promise<void>;
    showBookmarks: () => Promise<void>;
    private search;
    private getDefaultOpenMode();
    private isInstallDirectoryOrHome();
}
