import * as Oni from "oni-api";
export declare enum QuickOpenType {
    bookmark = 0,
    bookmarkHelp = 1,
    file = 2,
    folder = 3,
    folderHelp = 4,
    bufferLine = 5,
}
export declare function getTypeFromMenuItem(item: Oni.Menu.MenuOption): QuickOpenType;
export declare type IToMenuItem = (qo: QuickOpenItem) => Oni.Menu.MenuOption;
export declare class QuickOpenItem {
    private _label;
    private _detail;
    private _type;
    private _path;
    private _line;
    private _column;
    constructor(_label: string, _detail: string, _type: QuickOpenType, _path?: string, _line?: number, _column?: number);
    toMenuItem(oni: Oni.Plugin.Api, pinned: boolean): Oni.Menu.MenuOption;
    toQuickFixItem(): Oni.QuickFixEntry;
    readonly hash: string;
    private getIcon(oni);
}
