"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const logs = [];
let _isVerbose = false;
const isVerbose = () => process.argv.filter(arg => arg.indexOf("--verbose") >= 0).length > 0 || _isVerbose;
exports.setVerbose = (verbose) => {
    _isVerbose = verbose;
};
exports.info = (msg) => {
    if (isVerbose()) {
        console.log(msg);
    }
    logs.push(msg);
};
exports.warn = (msg) => {
    if (isVerbose()) {
        console.warn(msg);
    }
    logs.push(msg);
};
exports.getAllLogs = () => {
    return logs;
};
//# sourceMappingURL=Log.js.map