"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const electron_1 = require("electron");
exports.makeSingleInstance = (options, callbackFunction) => {
    const isSecondInstance = electron_1.app.makeSingleInstance((args, workingDirectory) => {
        callbackFunction({
            args,
            workingDirectory,
        });
    });
    if (isSecondInstance) {
        electron_1.app.quit();
    }
    electron_1.app.on("ready", () => {
        callbackFunction(options);
    });
};
//# sourceMappingURL=ProcessLifecycle.js.map