"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Log = require("./Log");
exports.default = () => __awaiter(this, void 0, void 0, function* () {
    try {
        const { REACT_DEVELOPER_TOOLS, REDUX_DEVTOOLS, default: installExtension, } = require("electron-devtools-installer");
        try {
            const reduxExt = yield installExtension(REDUX_DEVTOOLS);
            Log.info(`Added extension: ${reduxExt}`);
            const reactExt = yield installExtension(REACT_DEVELOPER_TOOLS);
            Log.info(`Added extension: ${reactExt}`);
        }
        catch (e) {
            Log.info(`An error occurred: ${e}`);
        }
    }
    catch (ex) {
        Log.warn("Unable to install developer tools. `electron-devtools-installer` may not be available in this environment");
    }
});
//# sourceMappingURL=installDevTools.js.map