"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const vscode_uri_1 = require("vscode-uri");
const command = require("../command");
function default_1(session) {
    return (event) => __awaiter(this, void 0, void 0, function* () {
        for (const id of event.changes) {
            const p = path.parse(vscode_uri_1.default.parse(id.uri).path);
            if (".ml" === p.ext) {
                return session.indexer.refreshSymbols(id);
            }
            if (".re" === p.ext) {
                return session.indexer.refreshSymbols(id);
            }
            if (".merlin" === p.base) {
                return command.restartMerlin(session);
            }
            if ("command-exec" === p.name) {
                return command.restartMerlin(session);
            }
        }
    });
}
exports.default = default_1;
//# sourceMappingURL=didChangeWatchedFiles.js.map