"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const deepmerge = require("deepmerge");
const merlin = require("./merlin");
exports.merlin = merlin;
const remote = require("./remote");
exports.remote = remote;
const types = require("./types");
exports.types = types;
var ISettings;
(function (ISettings) {
    ISettings.defaults = {
        reason: {
            codelens: {
                enabled: true,
                unicode: true,
            },
            debounce: {
                linter: 500,
            },
            diagnostics: {
                merlinPerfLogging: false,
                tools: ["merlin"],
            },
            format: {
                width: null,
            },
            path: {
                bsb: "bsb",
                env: "env",
                esy: "esy",
                ocamlfind: "ocamlfind",
                ocamlmerlin: "ocamlmerlin",
                opam: "opam",
                rebuild: "rebuild",
                refmt: "refmt",
                refmterr: "refmterr",
                rtop: "rtop",
            },
            server: {
                languages: ["ocaml", "reason"],
            },
        },
    };
    function withDefaults(overrides) {
        return deepmerge(overrides || {}, ISettings.defaults);
    }
    ISettings.withDefaults = withDefaults;
})(ISettings = exports.ISettings || (exports.ISettings = {}));
//# sourceMappingURL=index.js.map