"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Search = require("./Search");
exports.Search = Search;
const Ui = require("./Ui");
exports.Ui = Ui;
var FileOpenMode;
(function (FileOpenMode) {
    // Open file in existing editor / tab, if it is already open.
    // Otherwise, open in a new tab in the active editor.
    FileOpenMode[FileOpenMode["Edit"] = 0] = "Edit";
    // Open file in a new vertical split
    FileOpenMode[FileOpenMode["VerticalSplit"] = 1] = "VerticalSplit";
    // Open file in a new horizontal split
    FileOpenMode[FileOpenMode["HorizontalSplit"] = 2] = "HorizontalSplit";
    // Open file in a new tab, in the active editor
    FileOpenMode[FileOpenMode["NewTab"] = 3] = "NewTab";
    // Open file in existing tab. Replaces the currently
    // active file in the tab.
    FileOpenMode[FileOpenMode["ExistingTab"] = 4] = "ExistingTab";
})(FileOpenMode = exports.FileOpenMode || (exports.FileOpenMode = {}));
exports.DefaultFileOpenOptions = {
    openMode: FileOpenMode.Edit,
};
var Shapes;
(function (Shapes) {
    let Rectangle;
    (function (Rectangle) {
        function create(x, y, width, height) {
            return {
                x,
                y,
                width,
                height,
            };
        }
        Rectangle.create = create;
    })(Rectangle = Shapes.Rectangle || (Shapes.Rectangle = {}));
})(Shapes = exports.Shapes || (exports.Shapes = {}));
var ToolTip;
(function (ToolTip) {
    let OpenDirection;
    (function (OpenDirection) {
        OpenDirection[OpenDirection["Up"] = 1] = "Up";
        OpenDirection[OpenDirection["Down"] = 2] = "Down";
    })(OpenDirection = ToolTip.OpenDirection || (ToolTip.OpenDirection = {}));
})(ToolTip = exports.ToolTip || (exports.ToolTip = {}));
