/**
 * Git.ts
 *
 */
import * as Oni from "oni-api";
import { IEvent } from "oni-types";
import * as GitP from "simple-git/promise";
import * as VCS from "./vcs";
export declare class GitVersionControlProvider implements VCS.VersionControlProvider {
    private _oni;
    private _git;
    private readonly _name;
    private _onPluginActivated;
    private _onPluginDeactivated;
    private _onBranchChange;
    private _onStagedFilesChanged;
    private _onFileStatusChanged;
    private _isActivated;
    private _projectRoot;
    constructor(_oni: Oni.Plugin.Api, _git?: typeof GitP);
    readonly onBranchChanged: IEvent<VCS.BranchChangedEvent>;
    readonly onFileStatusChanged: IEvent<VCS.FileStatusChangedEvent>;
    readonly onStagedFilesChanged: IEvent<VCS.StagedFilesChangedEvent>;
    readonly onPluginActivated: IEvent<void>;
    readonly onPluginDeactivated: IEvent<void>;
    readonly isActivated: boolean;
    readonly name: VCS.SupportedProviders;
    activate(): void;
    deactivate(): void;
    canHandleWorkspace(dir?: string): Promise<boolean>;
    getRoot(): Promise<string>;
    getStatus: () => Promise<void | VCS.StatusResult>;
    getBlame: (args: VCS.BlameArgs) => Promise<VCS.Blame>;
    unstage: (files: string[]) => Promise<void>;
    uncommit: (sha?: string) => Promise<void>;
    getLogs: (file?: string) => Promise<VCS.ListLogSummary<VCS.DefaultLogFields>>;
    getDiff: () => Promise<GitP.DiffResult>;
    commitFiles: (message: string[], files?: string[]) => Promise<VCS.Commits>;
    stageFile: (file: string) => Promise<void>;
    fetchBranchFromRemote: ({ branch, currentDir, remote, }: {
        branch: string;
        remote: string;
        currentDir: string;
    }) => Promise<GitP.FetchResult>;
    getLocalBranches: () => Promise<GitP.BranchSummary>;
    getBranch: () => Promise<string | void>;
    changeBranch(targetBranch: string): Promise<void>;
    private _handleVCSError;
    private _formatRawBlame;
    private _isStaged;
    private _getModifiedAndStaged;
}
export declare const activate: (oni: any) => Promise<GitVersionControlProvider>;
