"use strict";
/**
 * oni-types
 *
 * Common types used by Oni
 */
Object.defineProperty(exports, "__esModule", { value: true });
const events_1 = require("events");
class Event {
    constructor(name) {
        this._eventObject = new events_1.EventEmitter();
        this._name = name || "default_event";
    }
    subscribe(callback) {
        this._eventObject.addListener(this._name, callback);
        const dispose = () => {
            this._eventObject.removeListener(this._name, callback);
        };
        return { dispose };
    }
    dispatch(val) {
        this._eventObject.emit(this._name, val);
    }
}
exports.Event = Event;
