"use strict";
/**
 * index.ts
 *
 * Entry point for ONI's TypeScript Language Service integraiton
 */
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var Utility = require("./Utility");
var lastCodeActionRequestInfo = null;
exports.getCodeActions = function (oni, host) { return function (protocolName, payload) { return __awaiter(_this, void 0, void 0, function () {
    var textDocument, range, filePath, val, convertApplicableRefactorToCommand, arrayOfCommandArrays, flattenedCommands;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                textDocument = payload.textDocument;
                range = payload.range;
                filePath = oni.language.unwrapFileUriPath(textDocument.uri);
                return [4 /*yield*/, host.getRefactors(filePath, range.start.line + 1, range.start.character + 1, range.end.line + 1, range.end.character + 1)];
            case 1:
                val = _a.sent();
                convertApplicableRefactorToCommand = function (refactor) {
                    var actions = refactor.actions || [];
                    return actions.map(function (action) { return ({
                        title: refactor.description + ": " + action.description,
                        command: refactor.name + "|" + action.name,
                    }); });
                };
                arrayOfCommandArrays = val.map(function (refactorInfo) {
                    return convertApplicableRefactorToCommand(refactorInfo);
                });
                flattenedCommands = [].concat.apply([], arrayOfCommandArrays);
                lastCodeActionRequestInfo = {
                    filePath: filePath,
                    range: range,
                };
                return [2 /*return*/, flattenedCommands];
        }
    });
}); }; };
exports.executeCommand = function (connection, oni, host) { return function (protocolName, payload) { return __awaiter(_this, void 0, void 0, function () {
    var command, args, language, _a, refactorName, actionName, val, changes;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                command = payload.command;
                args = payload.args || [];
                language = Utility.getLanguageFromFileName(lastCodeActionRequestInfo.filePath);
                _a = command.split("|"), refactorName = _a[0], actionName = _a[1];
                return [4 /*yield*/, host.getEditsForRefactor(refactorName, actionName, lastCodeActionRequestInfo.filePath, lastCodeActionRequestInfo.range.start.line + 1, lastCodeActionRequestInfo.range.start.character + 1, lastCodeActionRequestInfo.range.end.line + 1, lastCodeActionRequestInfo.range.end.character + 1)];
            case 1:
                val = _b.sent();
                changes = val.edits.reduce(function (prev, codeEdit) {
                    var file = oni.language.wrapPathInFileUri(codeEdit.fileName);
                    return __assign({}, prev, (_a = {}, _a[file] = codeEdit.textChanges.map(function (te) { return Utility.convertCodeEditToTextEdit(te); }), _a));
                    var _a;
                }, {});
                return [4 /*yield*/, connection.request("workspace/applyEdit", language, { edit: { changes: changes } })];
            case 2:
                _b.sent();
                return [2 /*return*/];
        }
    });
}); }; };
//# sourceMappingURL=CodeActions.js.map