/// <reference path="../../../../node_modules/typescript/lib/protocol.d.ts" />
/// <reference types="node" />
import * as events from "events";
export declare class TypeScriptServerHost extends events.EventEmitter {
    private _tssProcess;
    private _seqNumber;
    private _seqToPromises;
    private _rl;
    private _initPromise;
    private _openedFiles;
    readonly pid: number;
    constructor(Oni: any);
    _startTypescriptServer(Oni: any): Promise<void>;
    openFile(file: string, text?: string): Promise<any>;
    getProjectInfo(file: string): Promise<any>;
    getDefinition(file: string, line: number, offset: number): Promise<void>;
    getTypeDefinition(file: string, line: number, offset: number): Promise<void>;
    getFormattingEdits(file: string, line: number, offset: number, endLine: number, endOffset: number): Promise<protocol.CodeEdit[]>;
    getCompletions(file: string, line: number, offset: number, prefix: string): Promise<any>;
    getCompletionDetails(file: string, line: number, offset: number, entryNames: string[]): Promise<any>;
    getRefactors(file: string, startLine: number, startOffset: number, endLine: number, endOffset: number): Promise<protocol.ApplicableRefactorInfo[]>;
    getEditsForRefactor(refactor: string, action: string, file: string, startLine: number, startOffset: number, endLine: number, endOffset: number): Promise<protocol.RefactorEditInfo>;
    updateFile(file: string, fileContent: string): Promise<void>;
    changeLineInFile(file: string, line: number, newLineContents: string): Promise<void>;
    getQuickInfo(file: string, line: number, offset: number): Promise<any>;
    saveTo(file: string, tmpfile: string): Promise<void>;
    getSignatureHelp(file: string, line: number, offset: number): Promise<any>;
    getErrors(fullFilePath: string): Promise<void>;
    getErrorsAcrossProject(fullFilePath: string): Promise<void>;
    getNavigationTree(fullFilePath: string): Promise<protocol.NavigationTree>;
    getDocumentHighlights(file: string, line: number, offset: number): Promise<void>;
    findAllReferences(file: string, line: number, offset: number): Promise<protocol.ReferencesResponseBody>;
    navTo(file: string, query: string): Promise<protocol.NavtoItem[]>;
    rename(file: string, line: number, offset: number): Promise<protocol.RenameResponseBody>;
    _makeTssRequest<T>(commandName: string, args: any): Promise<T>;
    private _parseResponse(returnedData);
    private _createDeferredPromise<T>();
}
