"use strict";
/**
 * TypeScriptServerHost.ts
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var events = require("events");
var os = require("os");
var path = require("path");
var readline = require("readline");
var tssPath = path.join(__dirname, "..", "..", "..", "..", "node_modules", "typescript", "lib", "tsserver.js");
var TypeScriptServerHost = /** @class */ (function (_super) {
    __extends(TypeScriptServerHost, _super);
    function TypeScriptServerHost(Oni) {
        var _this = _super.call(this) || this;
        _this._tssProcess = null;
        _this._seqNumber = 0;
        _this._seqToPromises = {};
        _this._openedFiles = [];
        // Other tries for creating process:
        // this._tssProcess = childProcess.spawn("node", [tssPath], { stdio: "pipe", detached: true, shell: false });
        // this._tssProcess = childProcess.fork(tssPath, [], { stdio: "pipe "})
        //
        // On Windows, an 'npm' window would show up, so it seems like in this context,
        // exec was the most reliable
        // Note max buffer value - once this exceeded, the process will crash
        // TODO: Reload process, or looking at using the --eventPort option instead
        // This has some info on using eventPort: https://github.com/Microsoft/TypeScript/blob/master/src/server/server.ts
        // which might be more reliable
        // Can create the port using this here: https://github.com/Microsoft/TypeScript/blob/master/src/server/server.ts
        _this._initPromise = _this._startTypescriptServer(Oni);
        return _this;
    }
    Object.defineProperty(TypeScriptServerHost.prototype, "pid", {
        get: function () {
            return this._tssProcess.pid;
        },
        enumerable: true,
        configurable: true
    });
    TypeScriptServerHost.prototype._startTypescriptServer = function (Oni) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, Oni.process.spawnNodeScript(tssPath)];
                    case 1:
                        _a._tssProcess = _b.sent();
                        console.log("Process ID: " + this._tssProcess.pid); // tslint:disable-line no-console
                        this._rl = readline.createInterface({
                            input: this._tssProcess.stdout,
                            output: this._tssProcess.stdin,
                            terminal: false,
                        });
                        this._tssProcess.stderr.on("data", function (data, err) {
                            console.warn("Error from tss: " + data); // tslint:disable-line no-console
                        });
                        this._tssProcess.on("error", function (data) {
                            debugger; // tslint:disable-line no-debugger
                        });
                        this._tssProcess.on("exit", function (data) {
                            debugger; // tslint:disable-line no-debugger
                        });
                        this._tssProcess.on("close", function (data) {
                            debugger; // tslint:disable-line no-debugger
                        });
                        this._rl.on("line", function (msg) {
                            if (msg.indexOf("{") === 0) {
                                _this._parseResponse(msg);
                            }
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    TypeScriptServerHost.prototype.openFile = function (file, text) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this._openedFiles.indexOf(file) >= 0) {
                    return [2 /*return*/];
                }
                this._openedFiles.push(file);
                return [2 /*return*/, this._makeTssRequest("open", {
                        file: file,
                        fileContent: text,
                    })];
            });
        });
    };
    TypeScriptServerHost.prototype.getProjectInfo = function (file) {
        return this._makeTssRequest("projectInfo", {
            file: file,
            needFileNameList: true,
        });
    };
    TypeScriptServerHost.prototype.getDefinition = function (file, line, offset) {
        return this._makeTssRequest("definition", {
            file: file,
            line: line,
            offset: offset,
        });
    };
    TypeScriptServerHost.prototype.getTypeDefinition = function (file, line, offset) {
        return this._makeTssRequest("typeDefinition", {
            file: file,
            line: line,
            offset: offset,
        });
    };
    TypeScriptServerHost.prototype.getFormattingEdits = function (file, line, offset, endLine, endOffset) {
        return this._makeTssRequest("format", {
            file: file,
            line: line,
            offset: offset,
            endLine: endLine,
            endOffset: endOffset,
        });
    };
    TypeScriptServerHost.prototype.getCompletions = function (file, line, offset, prefix) {
        return this._makeTssRequest("completions", {
            file: file,
            line: line,
            offset: offset,
            prefix: prefix,
        });
    };
    TypeScriptServerHost.prototype.getCompletionDetails = function (file, line, offset, entryNames) {
        return this._makeTssRequest("completionEntryDetails", {
            file: file,
            line: line,
            offset: offset,
            entryNames: entryNames,
        });
    };
    TypeScriptServerHost.prototype.getRefactors = function (file, startLine, startOffset, endLine, endOffset) {
        return this._makeTssRequest("getApplicableRefactors", {
            file: file,
            startLine: startLine,
            startOffset: startOffset,
            endLine: endLine,
            endOffset: endOffset,
        });
    };
    TypeScriptServerHost.prototype.getEditsForRefactor = function (refactor, action, file, startLine, startOffset, endLine, endOffset) {
        return this._makeTssRequest("getEditsForRefactor", {
            refactor: refactor,
            action: action,
            file: file,
            startLine: startLine,
            startOffset: startOffset,
            endLine: endLine,
            endOffset: endOffset,
        });
    };
    TypeScriptServerHost.prototype.updateFile = function (file, fileContent) {
        var totalLines = fileContent.split(os.EOL);
        return this._makeTssRequest("change", {
            file: file,
            line: 1,
            offset: 1,
            endLine: totalLines.length + 1,
            endOffset: 1,
            insertString: fileContent,
        });
    };
    TypeScriptServerHost.prototype.changeLineInFile = function (file, line, newLineContents) {
        return this._makeTssRequest("change", {
            file: file,
            line: line,
            offset: 1,
            endOffset: 1,
            endLine: line + 1,
            insertString: newLineContents + os.EOL,
        });
    };
    TypeScriptServerHost.prototype.getQuickInfo = function (file, line, offset) {
        return this._makeTssRequest("quickinfo", {
            file: file,
            line: line,
            offset: offset,
        });
    };
    TypeScriptServerHost.prototype.saveTo = function (file, tmpfile) {
        return this._makeTssRequest("saveto", {
            file: file,
            tmpfile: tmpfile,
        });
    };
    TypeScriptServerHost.prototype.getSignatureHelp = function (file, line, offset) {
        return this._makeTssRequest("signatureHelp", {
            file: file,
            line: line,
            offset: offset,
        });
    };
    TypeScriptServerHost.prototype.getErrors = function (fullFilePath) {
        return this._makeTssRequest("geterr", {
            files: [fullFilePath],
            delay: 500,
        });
    };
    TypeScriptServerHost.prototype.getErrorsAcrossProject = function (fullFilePath) {
        return this._makeTssRequest("geterrForProject", {
            file: fullFilePath,
        });
    };
    TypeScriptServerHost.prototype.getNavigationTree = function (fullFilePath) {
        return this._makeTssRequest("navtree", {
            file: fullFilePath,
        });
    };
    TypeScriptServerHost.prototype.getDocumentHighlights = function (file, line, offset) {
        return this._makeTssRequest("documentHighlights", {
            file: file,
            line: line,
            offset: offset,
        });
    };
    TypeScriptServerHost.prototype.findAllReferences = function (file, line, offset) {
        return this._makeTssRequest("references", {
            file: file,
            line: line,
            offset: offset,
        });
    };
    TypeScriptServerHost.prototype.navTo = function (file, query) {
        return this._makeTssRequest("navto", {
            file: file,
            searchValue: query,
        });
    };
    TypeScriptServerHost.prototype.rename = function (file, line, offset) {
        return this._makeTssRequest("rename", {
            file: file,
            line: line,
            offset: offset,
            findInComments: false,
            findInStrings: false,
        });
    };
    TypeScriptServerHost.prototype._makeTssRequest = function (commandName, args) {
        return __awaiter(this, void 0, void 0, function () {
            var seq, payload, ret;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._initPromise];
                    case 1:
                        _a.sent();
                        seq = this._seqNumber++;
                        payload = {
                            seq: seq,
                            type: "request",
                            command: commandName,
                            arguments: args,
                        };
                        ret = this._createDeferredPromise();
                        this._seqToPromises[seq] = ret;
                        // TODO: Handle updates in parallel?
                        this._tssProcess.stdin.write(JSON.stringify(payload) + os.EOL);
                        return [2 /*return*/, ret.promise];
                }
            });
        });
    };
    TypeScriptServerHost.prototype._parseResponse = function (returnedData) {
        var response = JSON.parse(returnedData);
        var seq = response["request_seq"]; // tslint:disable-line no-string-literal
        var success = response["success"]; // tslint:disable-line no-string-literal
        if (typeof seq === "number") {
            if (success) {
                this._seqToPromises[seq].resolve(response.body);
            }
            else {
                this._seqToPromises[seq].reject(new Error(response.message));
            }
            this._seqToPromises[seq] = null;
        }
        else {
            // If a sequence wasn't specified, it might be a call that returns multiple results
            // Like 'geterr' - returns both semanticDiag and syntaxDiag
            if (response.type && response.type === "event") {
                if (response.event && response.event === "semanticDiag") {
                    this.emit("semanticDiag", response.body);
                }
            }
        }
    };
    TypeScriptServerHost.prototype._createDeferredPromise = function () {
        var resolve;
        var reject;
        var promise = new Promise(function (res, rej) {
            resolve = res;
            reject = rej;
        });
        return {
            resolve: resolve,
            reject: reject,
            promise: promise,
        };
    };
    return TypeScriptServerHost;
}(events.EventEmitter));
exports.TypeScriptServerHost = TypeScriptServerHost;
//# sourceMappingURL=TypeScriptServerHost.js.map